/**
 * @file test_pole_cover.c
 *
 * @copyright Copyright  (C)  2013 DKRZ, MPI-M
 *
 * @version 1.0
 *
 * @author Moritz Hanke <hanke@dkrz.de>
 *
 */
/*
 * Keywords:
 * Maintainer: Moritz Hanke <hanke@dkrz.de>
 *             Rene Redler <rene.redler@mpimet.mpg.de>
 * URL: https://doc.redmine.dkrz.de/YAC/html/index.html
 *
 * This file is part of YAC.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are  permitted provided that the following conditions are
 * met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * Neither the name of the DKRZ GmbH nor the names of its contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "tests.h"
#include "search.h"

int main (void) {

   double clon[5], clat[5];

   unsigned i;

   for (i = 0; i < 5; ++i) clat[i] = 88;

   clon[0] =  10*YAC_RAD;
   clon[1] =  70*YAC_RAD;
   clon[2] = 130*YAC_RAD;
   clon[3] = 190*YAC_RAD;
   clon[4] = 250*YAC_RAD;

   if (!yac_cell_covers_pole(5, clon, clat))
      PUT_ERR("error in yac_cell_covers_pole first test")

   clat[0] = 88.0*YAC_RAD; clon[0] =  50.0*YAC_RAD;
   clat[1] = 88.0*YAC_RAD; clon[1] =  70.0*YAC_RAD;
   clat[2] = 89.0*YAC_RAD; clon[2] =  75.0*YAC_RAD;
   clat[3] = 89.5*YAC_RAD; clon[3] =  60.0*YAC_RAD;
   clat[4] = 89.0*YAC_RAD; clon[4] =  45.0*YAC_RAD;

   if (yac_cell_covers_pole(5, clon, clat))
      PUT_ERR("error in yac_cell_covers_pole second test")

   clat[0] = -10*YAC_RAD; clon[0] =  300*YAC_RAD;
   clat[1] = -10*YAC_RAD; clon[1] =   60*YAC_RAD; // 420*YAC_RAD
   clat[2] =  10*YAC_RAD; clon[2] =   60*YAC_RAD; // 420*YAC_RAD
   clat[3] =  10*YAC_RAD; clon[3] =  300*YAC_RAD;

   if (yac_cell_covers_pole(4, clon, clat))
      PUT_ERR("error in yac_cell_covers_pole third test")

   return TEST_EXIT_CODE;
}

